/* Filename: filesync.c*/

#include <stdio.h>
#include <stdlib.h>
#include "Hash_tree.h"

int main(int argc, char *argv[])
{
    /*elengxos tou arithmou ton arguments*/
    if (argc < 5)
    {
        printf("Not enough arguments! The program will now exit...\n");
        return 0;
    }

    /*perasma tous se metavlites*/
    char* file_one = argv[1];
    char* file_two = argv[2];
    int page_size = atoi(argv[3]);
    int tree_fanout = atoi(argv[4]);
    
    /*elengxos tou tree fan-out*/
    if(tree_fanout < 2)
    {
        printf("Tree fan-out(last argument) must be 2 or greater! The program will now exit...\n");
        return 0; 
    }
    
    /*elengxos tou page-size*/
    if(page_size < 1)
    {
        printf("Page size(third argument) must be 1 or greater! The program will now exit...\n");
        return 0; 
    }    
    
    printf("File one name: %s\nFile two name: %s\nPage size: %d\nTree fan-out: %d\n\n",
            file_one, file_two, page_size, tree_fanout);
    
    /*dimiourgia kai kataskeui protou dentrou*/
    Hash_tree tree1;
    if(Hash_tree_create(&tree1, tree_fanout))
        return 1;
    if(Hash_tree_generate(file_one, tree1, page_size))
    {
        Hash_tree_destroy(&tree1);
        return 1;
    }

    /*dimiourgia kai kataskeui deuterou dentrou*/    
    Hash_tree tree2;
    if(Hash_tree_create(&tree2, tree_fanout))
    {
        Hash_tree_destroy(&tree1);
        return 1;        
    }        
    if(Hash_tree_generate(file_two, tree2, page_size))
    {
        Hash_tree_destroy(&tree1);
        Hash_tree_destroy(&tree2);
        return 1;
    }
    
    /*sygrisi ton dyo dentron*/
    Hash_tree_compare(tree1, tree2);
    
    /*katastrofi(apodesmeusi) ton dyo dentron*/
    Hash_tree_destroy(&tree1);
    Hash_tree_destroy(&tree2);

    return 0;
}

